"use strict";
var JsonApiModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonApiModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const utils_1 = require("./utils");
let JsonApiModule = JsonApiModule_1 = class JsonApiModule {
    static forRoot(first, second) {
        let resultOption = {};
        if (second) {
            const module = first;
            resultOption = {
                ...(0, utils_1.prepareConfig)(second, module.module),
                type: module,
            };
        }
        else {
            const { TypeOrmJsonApiModule, } = require('./modules/type-orm/type-orm-json-api.module');
            resultOption = {
                ...(0, utils_1.prepareConfig)(first, TypeOrmJsonApiModule.module),
                type: TypeOrmJsonApiModule,
            };
        }
        resultOption.imports.unshift(core_1.DiscoveryModule);
        const commonOrmModule = resultOption.type.forRoot(resultOption);
        const entitiesMixinModules = resultOption.entities.map((entity) => (0, utils_1.createMixinModule)(entity, resultOption, commonOrmModule));
        const operationModuleImport = (0, utils_1.createAtomicModule)(resultOption, entitiesMixinModules, commonOrmModule);
        return {
            module: JsonApiModule_1,
            imports: [...operationModuleImport, ...entitiesMixinModules],
        };
    }
};
exports.JsonApiModule = JsonApiModule;
exports.JsonApiModule = JsonApiModule = JsonApiModule_1 = tslib_1.__decorate([
    (0, common_1.Module)({})
], JsonApiModule);
//# sourceMappingURL=json-api.module.js.map