import { TestingModule } from '@nestjs/testing';
import { MikroOrmModule } from '@mikro-orm/nestjs';
import { EntityManager, MikroORM } from '@mikro-orm/core';
import { Addresses, Comments, Notes, Roles, UserGroups, Users } from './entities';
import { ObjectLiteral } from '../../types';
import { Query } from '../../modules/mixin/zod';
export * from './entities';
export * from './utils';
export declare const entities: (typeof Users | typeof Addresses | typeof Roles | typeof Comments | typeof Notes | typeof UserGroups)[];
export declare function mockDbPgLiteTestModule(dbName?: string): {
    module: typeof MikroOrmModule;
    providers: {
        provide: typeof MikroORM;
        useFactory: () => Promise<MikroORM<import("@mikro-orm/postgresql").PostgreSqlDriver, import("@mikro-orm/knex").EntityManager<import("@mikro-orm/postgresql").PostgreSqlDriver> & EntityManager<import("@mikro-orm/core").IDatabaseDriver<import("@mikro-orm/core").Connection>>>>;
    }[];
    exports: {
        provide: typeof MikroORM;
        useFactory: () => Promise<MikroORM<import("@mikro-orm/postgresql").PostgreSqlDriver, import("@mikro-orm/knex").EntityManager<import("@mikro-orm/postgresql").PostgreSqlDriver> & EntityManager<import("@mikro-orm/core").IDatabaseDriver<import("@mikro-orm/core").Connection>>>>;
    }[];
};
export declare function dbRandomName(readOnly?: boolean): string;
export declare function pullData(em: EntityManager, count?: number): Promise<void>;
export declare function getModuleForPgLite<E extends ObjectLiteral>(entity: E, dbName?: string): Promise<TestingModule>;
export declare function getDefaultQuery<R extends ObjectLiteral>(): Query<R>;
