"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.entities = void 0;
exports.mockDBTestModule = mockDBTestModule;
const tslib_1 = require("tslib");
const typeorm_1 = require("@nestjs/typeorm");
const entities_1 = require("./entities");
tslib_1.__exportStar(require("./entities"), exports);
tslib_1.__exportStar(require("./utils"), exports);
exports.entities = [
    entities_1.Users,
    entities_1.UserGroups,
    entities_1.Roles,
    entities_1.RequestsHavePodLocks,
    entities_1.Requests,
    entities_1.Pods,
    entities_1.Comments,
    entities_1.Addresses,
    entities_1.Notes,
];
function mockDBTestModule(db) {
    return typeorm_1.TypeOrmModule.forRootAsync({
        useFactory() {
            return {
                type: 'postgres',
                // logging: true,
                entities: [
                    entities_1.Users,
                    entities_1.UserGroups,
                    entities_1.Roles,
                    entities_1.RequestsHavePodLocks,
                    entities_1.Requests,
                    entities_1.Pods,
                    entities_1.Comments,
                    entities_1.Addresses,
                    entities_1.Notes,
                ],
            };
        },
        async dataSourceFactory(options) {
            const dataSource = await db.adapters.createTypeormDataSource(options);
            return dataSource;
        },
    });
}
//# sourceMappingURL=index.js.map