"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEntityName = exports.nameIt = void 0;
exports.getProviderName = getProviderName;
const nestjs_shared_1 = require("../../../utils/nestjs-shared");
const nameIt = (name, cls) => ({
    [name]: class extends cls {
        constructor(...arg) {
            super(...arg);
        }
    },
}[name]);
exports.nameIt = nameIt;
const getEntityName = (entity) => {
    if (typeof entity === 'string') {
        return entity;
    }
    if ('name' in entity) {
        return entity['name'];
    }
    if ('constructor' in entity && 'name' in entity.constructor) {
        return entity['constructor']['name'];
    }
    return `${entity}`;
};
exports.getEntityName = getEntityName;
function getProviderName(entity, name) {
    const entityName = (0, exports.getEntityName)(entity);
    return `${(0, nestjs_shared_1.upperFirstLetter)(entityName)}${name}`;
}
//# sourceMappingURL=utils.js.map