"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodPost = zodPost;
const zod_1 = require("zod");
const zod_share_1 = require("../zod-share");
function getShape(typeId, typeName, fieldWithType, propsDb, primaryColumn, relationArrayProps, relationPopsName, primaryColumnType) {
    const shape = {
        id: (0, zod_share_1.zodId)(typeId).optional(),
        type: (0, zod_share_1.zodType)(typeName),
        attributes: (0, zod_share_1.zodAttributes)(fieldWithType, propsDb, primaryColumn, false),
        relationships: (0, zod_share_1.zodRelationships)(relationArrayProps, relationPopsName, primaryColumnType, false).optional(),
    };
    return zod_1.z.object(shape).strict();
}
function zodDataShape(shape) {
    return zod_1.z
        .object({
        data: shape,
    })
        .strict();
}
function zodPost(typeId, typeName, fieldWithType, propsDb, primaryColumn, relationArrayProps, relationPopsName, primaryColumnType) {
    const shape = getShape(typeId, typeName, fieldWithType, propsDb, primaryColumn, relationArrayProps, relationPopsName, primaryColumnType);
    return zodDataShape(shape);
}
//# sourceMappingURL=index.js.map