import { FilterOperand } from '../../../../utils/nestjs-shared';
import { z } from 'zod';
import { RelationTree, ResultGetField, UnionToTuple, ZodInfer } from '../../types';
import { ObjectLiteral } from '../../../../types';
type FilterType = Partial<{
    [key in FilterOperand]: string | string[];
}>;
type OutPutFilter = {
    relation: null | Record<string, Record<string, FilterType>>;
    target: null | Record<string, FilterType>;
};
export declare function zodFilterInputQuery<E extends ObjectLiteral>(fields: ResultGetField<E>['field'], relationList: RelationTree<E>): z.ZodEffects<z.ZodOptional<z.ZodObject<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in import("../../types").TupleOfEntityProps<E, UnionToTuple<import("../../types").EntityProps<E>>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("../../types").EntityRelation<E>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof RelationTree<E>]: `${K_2 & string}.${RelationTree<E>[K_2][number]}`; }[import("../../types").EntityRelation<E>]>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }>, "strip", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in import("../../types").TupleOfEntityProps<E, UnionToTuple<import("../../types").EntityProps<E>>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("../../types").EntityRelation<E>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof RelationTree<E>]: `${K_2 & string}.${RelationTree<E>[K_2][number]}`; }[import("../../types").EntityRelation<E>]>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in import("../../types").TupleOfEntityProps<E, UnionToTuple<import("../../types").EntityProps<E>>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("../../types").EntityRelation<E>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof RelationTree<E>]: `${K_2 & string}.${RelationTree<E>[K_2][number]}`; }[import("../../types").EntityRelation<E>]>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }>>, any>[k]; } : never, z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in import("../../types").TupleOfEntityProps<E, UnionToTuple<import("../../types").EntityProps<E>>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("../../types").EntityRelation<E>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof RelationTree<E>]: `${K_2 & string}.${RelationTree<E>[K_2][number]}`; }[import("../../types").EntityRelation<E>]>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in import("../../types").TupleOfEntityProps<E, UnionToTuple<import("../../types").EntityProps<E>>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("../../types").EntityRelation<E>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof RelationTree<E>]: `${K_2 & string}.${RelationTree<E>[K_2][number]}`; }[import("../../types").EntityRelation<E>]>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }>>[k_1]; } : never>>, OutPutFilter, (z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in import("../../types").TupleOfEntityProps<E, UnionToTuple<import("../../types").EntityProps<E>>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("../../types").EntityRelation<E>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof RelationTree<E>]: `${K_2 & string}.${RelationTree<E>[K_2][number]}`; }[import("../../types").EntityRelation<E>]>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<z.objectUtil.extendShape<z.objectUtil.extendShape<{ [K in import("../../types").TupleOfEntityProps<E, UnionToTuple<import("../../types").EntityProps<E>>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }, { [K_1 in UnionToTuple<import("../../types").EntityRelation<E>>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodObject<{
    eq: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    eq: null;
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodEffects<z.ZodUnion<[z.ZodLiteral<"null">, z.ZodNull]>, null, "null" | null>;
}, "strict", z.ZodTypeAny, {
    ne: null;
}, {
    ne: "null" | null;
}>]>>; }>, { [K_3 in UnionToTuple<{ [K_2 in keyof RelationTree<E>]: `${K_2 & string}.${RelationTree<E>[K_2][number]}`; }[import("../../types").EntityRelation<E>]>[number]]: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>, z.ZodEffects<z.ZodObject<{
    eq: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    gte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    like: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lt: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    lte: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    ne: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    regexp: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    in: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
    some: z.ZodOptional<z.ZodEffects<z.ZodUnion<[z.ZodEffects<z.ZodString, string, string>, z.ZodNull, z.ZodNumber]>, string, string | number | null>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: string | undefined;
    nin?: string | undefined;
    some?: string | undefined;
}, {
    eq?: string | number | null | undefined;
    gt?: string | number | null | undefined;
    gte?: string | number | null | undefined;
    like?: string | number | null | undefined;
    lt?: string | number | null | undefined;
    lte?: string | number | null | undefined;
    ne?: string | number | null | undefined;
    regexp?: string | number | null | undefined;
    in?: string | number | null | undefined;
    nin?: string | number | null | undefined;
    some?: string | number | null | undefined;
}>]>>; }>>[k_1]; } : never) | undefined>;
export type ZodFilterInputQuery<E extends ObjectLiteral> = ZodInfer<typeof zodFilterInputQuery<E>>;
export {};
