"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodInputQuery = zodInputQuery;
const nestjs_shared_1 = require("../../../../utils/nestjs-shared");
const zod_1 = require("zod");
const fields_1 = require("./fields");
const filter_1 = require("./filter");
const include_1 = require("./include");
const sort_1 = require("./sort");
const zod_share_1 = require("../zod-share");
function zodInputQuery(entityFieldsStructure, entityRelationStructure) {
    return zod_1.z
        .object({
        [nestjs_shared_1.QueryField.fields]: (0, fields_1.zodFieldsInputQuery)(entityFieldsStructure.relations),
        [nestjs_shared_1.QueryField.filter]: (0, filter_1.zodFilterInputQuery)(entityFieldsStructure.field, entityRelationStructure),
        [nestjs_shared_1.QueryField.include]: (0, include_1.zodIncludeInputQuery)(),
        [nestjs_shared_1.QueryField.sort]: (0, sort_1.zodSortInputQuery)(),
        [nestjs_shared_1.QueryField.page]: (0, zod_share_1.zodPageInputQuery)(),
    })
        .strict(`Query object should contain only allow params: "${Object.keys(nestjs_shared_1.QueryField).join('"."')}"`);
}
//# sourceMappingURL=index.js.map