import { z, ZodOptional } from 'zod';
import { AllFieldWithType, ArrayPropsForEntity, RelationTree, ResultGetField, IsArray, TypeField, EntityProps, TypeOfArray } from '../../types';
import { ObjectLiteral } from '../../../../types';
declare const zodRuleFilterRelationSchema: z.ZodUnion<[z.ZodObject<{
    eq: z.ZodUnion<[z.ZodLiteral<"null">, z.ZodEffects<z.ZodLiteral<null>, "null", null>]>;
}, "strict", z.ZodTypeAny, {
    eq: "null";
}, {
    eq: "null" | null;
}>, z.ZodObject<{
    ne: z.ZodUnion<[z.ZodLiteral<"null">, z.ZodEffects<z.ZodLiteral<null>, "null", null>]>;
}, "strict", z.ZodTypeAny, {
    ne: "null";
}, {
    ne: "null" | null;
}>]>;
declare const zodRuleForArrayField: z.ZodObject<{
    some: z.ZodEffects<z.ZodArray<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>, "atleastone">, [string | null, ...(string | null)[]], [string, ...string[]]>;
}, "strict", z.ZodTypeAny, {
    some: [string | null, ...(string | null)[]];
}, {
    some: [string, ...string[]];
}>;
declare function getZodRulesForField(type?: TypeField): z.ZodEffects<z.ZodObject<{
    in: z.ZodOptional<z.ZodEffects<z.ZodArray<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>, "atleastone">, [string | null, ...(string | null)[]], [string, ...string[]]>>;
    nin: z.ZodOptional<z.ZodEffects<z.ZodArray<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>, "atleastone">, [string | null, ...(string | null)[]], [string, ...string[]]>>;
    eq: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    gt: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    gte: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    like: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    lt: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    lte: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    ne: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
    regexp: z.ZodOptional<z.ZodUnion<[z.ZodEffects<z.ZodLiteral<"null">, null, "null">, z.ZodEffects<z.ZodString, string, string>]>>;
}, "strict", z.ZodTypeAny, {
    eq?: string | null | undefined;
    gt?: string | null | undefined;
    gte?: string | null | undefined;
    like?: string | null | undefined;
    lt?: string | null | undefined;
    lte?: string | null | undefined;
    ne?: string | null | undefined;
    regexp?: string | null | undefined;
    in?: [string | null, ...(string | null)[]] | undefined;
    nin?: [string | null, ...(string | null)[]] | undefined;
}, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: [string, ...string[]] | undefined;
    nin?: [string, ...string[]] | undefined;
}>, {
    eq?: string | null | undefined;
    gt?: string | null | undefined;
    gte?: string | null | undefined;
    like?: string | null | undefined;
    lt?: string | null | undefined;
    lte?: string | null | undefined;
    ne?: string | null | undefined;
    regexp?: string | null | undefined;
    in?: [string | null, ...(string | null)[]] | undefined;
    nin?: [string | null, ...(string | null)[]] | undefined;
}, {
    eq?: string | undefined;
    gt?: string | undefined;
    gte?: string | undefined;
    like?: string | undefined;
    lt?: string | undefined;
    lte?: string | undefined;
    ne?: string | undefined;
    regexp?: string | undefined;
    in?: [string, ...string[]] | undefined;
    nin?: [string, ...string[]] | undefined;
}>;
declare function getZodRulesForRelationShape<E extends ObjectLiteral>(shape: FilterProps<E, ResultGetField<E>['field']>): z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>>>[k_1]; } : never) | undefined>;
type ZodRuleFilterRelationSchema = typeof zodRuleFilterRelationSchema;
type ZodRuleForArrayField = typeof zodRuleForArrayField;
type ZodRulesForField = ReturnType<typeof getZodRulesForField>;
type ZodRulesForRelationShape<E extends ObjectLiteral> = ReturnType<typeof getZodRulesForRelationShape<E>>;
type FilterProps<E extends ObjectLiteral, P extends readonly [string, ...string[]]> = {
    [Props in P[number]]: Props extends keyof E ? IsArray<E[Props]> extends true ? ZodOptional<ZodRuleForArrayField> : ZodOptional<ZodRulesForField> : never;
};
type RelationFilterProps<E extends ObjectLiteral> = {
    [R in keyof RelationTree<E>]: ZodRulesForRelationShape<TypeOfArray<E[R]>>;
};
type TargetRelationShape<E extends ObjectLiteral> = {
    [K in ResultGetField<E>['relations'][number]]: ZodOptional<ZodRuleFilterRelationSchema>;
};
export declare function zodFilterQuery<E extends ObjectLiteral>(fields: ResultGetField<E>['field'], relationTree: RelationTree<E>, propsArray: ArrayPropsForEntity<E>, propsType: AllFieldWithType<E>): z.ZodEffects<z.ZodObject<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}>, any> extends infer T_4 ? { [k_4 in keyof T_4]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}>, any>[k_4]; } : never, z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}> extends infer T_5 ? { [k_5 in keyof T_5]: z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}>[k_5]; } : never>, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}>, any> extends infer T_4 ? { [k_4 in keyof T_4]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}>, any>[k_4]; } : never, z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}> extends infer T_5 ? { [k_5 in keyof T_5]: z.baseObjectInputType<{
    target: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never, z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any> extends infer T ? { [k in keyof T]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>, any>[k]; } : never) | undefined, (z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>> extends infer T_1 ? { [k_1 in keyof T_1]: z.baseObjectInputType<FilterProps<E, import("../../types").TupleOfEntityProps<E, import("../../types").UnionToTuple<EntityProps<E>>>> & TargetRelationShape<E>>[k_1]; } : never) | undefined>>;
    relation: z.ZodNullable<z.ZodEffects<z.ZodOptional<z.ZodObject<RelationFilterProps<E>, "strict", z.ZodTypeAny, z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never, z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never>>, (z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any> extends infer T_2 ? { [k_2 in keyof T_2]: z.objectUtil.addQuestionMarks<z.baseObjectOutputType<RelationFilterProps<E>>, any>[k_2]; } : never) | undefined, (z.baseObjectInputType<RelationFilterProps<E>> extends infer T_3 ? { [k_3 in keyof T_3]: z.baseObjectInputType<RelationFilterProps<E>>[k_3]; } : never) | undefined>>;
}>[k_5]; } : never>;
export type ZodFilterQuery<E extends ObjectLiteral> = ReturnType<typeof zodFilterQuery<E>>;
export type FilterQuery<E extends ObjectLiteral> = z.infer<ZodFilterQuery<E>>;
export {};
