import { FactoryProvider } from '@nestjs/common';
import { DataSource, EntityManager, Repository } from 'typeorm';
import { FindOneRowEntity, CheckRelationNme, ZodEntityProps } from '../../mixin/types';
import { ObjectLiteral, RunInTransaction, EntityClass } from '../../../types';
import { TypeOrmService } from '../service';
export declare function CurrentDataSourceProvider(connectionName?: string): FactoryProvider<DataSource>;
export declare function CurrentEntityManager(): FactoryProvider<EntityManager>;
export declare function CurrentEntityRepository<E extends ObjectLiteral>(entity: E): FactoryProvider<Repository<E>>;
export declare function EntityPropsMap<E extends ObjectLiteral>(entities: EntityClass<E>[]): {
    provide: symbol;
    inject: symbol[];
    useFactory: (entityManager: EntityManager) => Map<EntityClass<E>, ZodEntityProps<E>>;
};
export declare function FindOneRowEntityFactory<E extends ObjectLiteral>(): FactoryProvider<FindOneRowEntity<E>>;
export declare function CheckRelationNameFactory<E extends ObjectLiteral>(): FactoryProvider<CheckRelationNme<E>>;
export declare function RunInTransactionFactory(): FactoryProvider<RunInTransaction>;
export declare function OrmServiceFactory(): {
    provide: symbol;
    useClass: typeof TypeOrmService;
};
