"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeOrmJsonApiModule = void 0;
const typeorm_1 = require("@nestjs/typeorm");
const factory_1 = require("./factory");
const service_1 = require("./service");
const constants_1 = require("../../constants");
class TypeOrmJsonApiModule {
    static module = 'typeOrm';
    static forRoot(options) {
        const optionProvider = {
            provide: constants_1.GLOBAL_MODULE_OPTIONS_TOKEN,
            useValue: options,
        };
        const typeOrmModule = typeorm_1.TypeOrmModule.forFeature(options.entities, options.connectionName);
        const currentProvider = [
            ...(options.providers || []),
            optionProvider,
            (0, factory_1.CurrentDataSourceProvider)(options.connectionName),
            (0, factory_1.CurrentEntityManager)(),
            (0, factory_1.EntityPropsMap)(options.entities),
            (0, factory_1.RunInTransactionFactory)(),
        ];
        const currentImport = [typeOrmModule, ...(options.imports || [])];
        return {
            module: TypeOrmJsonApiModule,
            imports: currentImport,
            providers: currentProvider,
            exports: [...currentProvider, ...currentImport],
        };
    }
    static getUtilProviders(entity) {
        return [
            (0, factory_1.CurrentEntityRepository)(entity),
            service_1.TypeormUtilsService,
            (0, factory_1.OrmServiceFactory)(),
            (0, factory_1.FindOneRowEntityFactory)(),
            (0, factory_1.CheckRelationNameFactory)(),
        ];
    }
}
exports.TypeOrmJsonApiModule = TypeOrmJsonApiModule;
//# sourceMappingURL=type-orm-json-api.module.js.map