"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.userFieldsStructure = exports.relationList = exports.propsType = exports.userRelations = exports.userFields = exports.primaryColumnType = exports.relationPopsName = exports.relationArrayProps = exports.fieldTypeAddresses = exports.propsDb = exports.fieldTypeUsers = void 0;
// @ts-nocheck
const types_1 = require("../../modules/mixin/types");
exports.fieldTypeUsers = {
    id: types_1.TypeField.number,
    isActive: types_1.TypeField.boolean,
    firstName: types_1.TypeField.string,
    createdAt: types_1.TypeField.date,
    lastName: types_1.TypeField.string,
    login: types_1.TypeField.string,
    testDate: types_1.TypeField.date,
    updatedAt: types_1.TypeField.date,
    testReal: types_1.TypeField.array,
    testArrayNull: types_1.TypeField.array,
};
exports.propsDb = {
    id: { type: Number, isArray: false, isNullable: false },
    login: { type: 'varchar', isArray: false, isNullable: false },
    firstName: { type: 'varchar', isArray: false, isNullable: true },
    testReal: { type: 'real', isArray: true, isNullable: false },
    testArrayNull: { type: 'real', isArray: true, isNullable: true },
    lastName: { type: 'varchar', isArray: false, isNullable: true },
    isActive: { type: 'boolean', isArray: false, isNullable: true },
    createdAt: { type: 'timestamp', isArray: false, isNullable: true },
    testDate: { type: 'timestamp', isArray: false, isNullable: true },
    updatedAt: { type: 'timestamp', isArray: false, isNullable: true },
    notes: { type: 'string', isArray: false, isNullable: true },
    roles: { type: 'number', isArray: true, isNullable: true },
    addresses: { type: 'number', isArray: true, isNullable: true },
    userGroup: { type: 'number', isArray: false, isNullable: true },
    manager: { type: 'number', isArray: false, isNullable: true },
    comments: { type: 'number', isArray: true, isNullable: true },
};
exports.fieldTypeAddresses = {
    id: types_1.TypeField.number,
    arrayField: types_1.TypeField.array,
    state: types_1.TypeField.string,
    city: types_1.TypeField.string,
    createdAt: types_1.TypeField.date,
    updatedAt: types_1.TypeField.date,
    country: types_1.TypeField.string,
};
exports.relationArrayProps = {
    roles: true,
    userGroup: false,
    notes: true,
    addresses: false,
    comments: true,
    manager: false,
};
exports.relationPopsName = {
    roles: 'Roles',
    userGroup: 'UserGroups',
    notes: 'Notes',
    addresses: 'Addresses',
    comments: 'Comments',
    manager: 'Users',
};
exports.primaryColumnType = {
    roles: types_1.TypeField.number,
    userGroup: types_1.TypeField.number,
    notes: types_1.TypeField.string,
    addresses: types_1.TypeField.number,
    comments: types_1.TypeField.number,
    manager: types_1.TypeField.number,
};
exports.userFields = [
    'updatedAt',
    'testDate',
    'createdAt',
    'isActive',
    'lastName',
    'testArrayNull',
    'testReal',
    'firstName',
    'login',
    'id',
];
exports.userRelations = {
    addresses: [
        'arrayField',
        'country',
        'state',
        'city',
        'updatedAt',
        'createdAt',
        'id',
    ],
    manager: [
        'updatedAt',
        'testDate',
        'createdAt',
        'isActive',
        'lastName',
        'testArrayNull',
        'testReal',
        'firstName',
        'login',
        'id',
    ],
    roles: ['isDefault', 'key', 'name', 'updatedAt', 'createdAt', 'id'],
    comments: ['kind', 'text', 'updatedAt', 'createdAt', 'id'],
    notes: ['text', 'updatedAt', 'createdAt', 'id'],
    userGroup: ['label', 'id'],
};
exports.propsType = {
    updatedAt: types_1.TypeField.date,
    testDate: types_1.TypeField.date,
    createdAt: types_1.TypeField.date,
    isActive: types_1.TypeField.boolean,
    lastName: types_1.TypeField.string,
    testArrayNull: types_1.TypeField.array,
    testReal: types_1.TypeField.array,
    firstName: types_1.TypeField.string,
    login: types_1.TypeField.string,
    id: types_1.TypeField.number,
    addresses: {
        arrayField: types_1.TypeField.array,
        country: types_1.TypeField.string,
        state: types_1.TypeField.string,
        city: types_1.TypeField.string,
        updatedAt: types_1.TypeField.date,
        createdAt: types_1.TypeField.date,
        id: types_1.TypeField.number,
    },
    manager: {
        updatedAt: types_1.TypeField.date,
        testDate: types_1.TypeField.date,
        createdAt: types_1.TypeField.date,
        isActive: types_1.TypeField.boolean,
        lastName: types_1.TypeField.string,
        testArrayNull: types_1.TypeField.array,
        testReal: types_1.TypeField.array,
        firstName: types_1.TypeField.string,
        login: types_1.TypeField.string,
        id: types_1.TypeField.number,
    },
    roles: {
        isDefault: types_1.TypeField.boolean,
        key: types_1.TypeField.string,
        name: types_1.TypeField.string,
        updatedAt: types_1.TypeField.date,
        createdAt: types_1.TypeField.date,
        id: types_1.TypeField.number,
    },
    comments: {
        kind: types_1.TypeField.string,
        text: types_1.TypeField.string,
        updatedAt: types_1.TypeField.date,
        createdAt: types_1.TypeField.date,
        id: types_1.TypeField.number,
    },
    notes: {
        text: types_1.TypeField.string,
        updatedAt: types_1.TypeField.date,
        createdAt: types_1.TypeField.date,
        id: types_1.TypeField.string,
    },
    userGroup: {
        label: types_1.TypeField.string,
        id: types_1.TypeField.number,
    },
};
exports.relationList = [
    'userGroup',
    'notes',
    'comments',
    'roles',
    'manager',
    'addresses',
];
exports.userFieldsStructure = {
    field: [
        'updatedAt',
        'testDate',
        'createdAt',
        'isActive',
        'lastName',
        'testArrayNull',
        'testReal',
        'firstName',
        'login',
        'id',
    ],
    relations: [
        'userGroup',
        'notes',
        'comments',
        'roles',
        'manager',
        'addresses',
    ],
};
//# sourceMappingURL=test.helper.js.map