"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectTyped = void 0;
exports.isObject = isObject;
exports.createEntityInstance = createEntityInstance;
const string_utils_1 = require("./string-utils");
exports.ObjectTyped = {
    keys: Object.keys,
    values: Object.values,
    entries: Object.entries,
    fromEntries: Object.fromEntries,
};
function isObject(item) {
    return typeof item === 'object' && !Array.isArray(item) && item !== null;
}
function createEntityInstance(name) {
    const entityName = (0, string_utils_1.kebabToCamel)(name);
    return Function('return new class ' + entityName + '{}')();
}
//# sourceMappingURL=object-utils.js.map